//---------------------------------------------------------------------------

#include <vcl.h>
#include <mmsystem.h>
#include <math.h>
#pragma hdrstop

#include "Generator.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
FGErrMsg PrepareDevice(void)
{
 pwfx=new WAVEFORMATEX;
 pwfx->wFormatTag=WAVE_FORMAT_PCM;
 pwfx->nChannels=2;
 pwfx->nSamplesPerSec=SPS;
 pwfx->nAvgBytesPerSec=SPS*2;
 pwfx->nBlockAlign=2;
 pwfx->wBitsPerSample=8;
 mmres=waveOutOpen(&ghwo,uDeviceID,pwfx,dwCallback,dwCallbackInstance,fdwOpen);
 delete pwfx;
 if(mmres != MMSYSERR_NOERROR)
 {
  return "Cant open device.";
 }
 buf=new unsigned char[SPS*2];
 if(buf == NULL)
 {
  CloseDevice();
  return "Cant allocate memory.";
 }
 pwh.lpData=buf;
 pwh.dwBufferLength=SPS*2;
 pwh.dwFlags=WHDR_BEGINLOOP;
 pwh.dwLoops=1;
 mmres = waveOutPrepareHeader(ghwo,&pwh,sizeof(pwh));
 pwh.dwFlags=WHDR_BEGINLOOP|WHDR_ENDLOOP|WHDR_PREPARED;
 pwh.dwLoops=0xFFFFFFFF;                // Number of loops == about 136 years:)
 if(mmres != MMSYSERR_NOERROR)
 {
  CloseDevice();
  return "Device prepare error.";
 }
 return NULL;
}

//---------------------------------------------------------------------------
FGErrMsg CloseDevice(void)
{
 delete [] buf;
 mmres=waveOutReset(ghwo);
 if(mmres != MMSYSERR_NOERROR)
  return "Cant close device.";
 mmres=waveOutClose(ghwo);
 if(mmres != MMSYSERR_NOERROR)
  return "Cant close device.";
 return NULL;
}

//---------------------------------------------------------------------------

inline void FillBuf(int freq,char amp,float phase,bool chan)
{
 int cnt=chan;
 register float x=freq*3.1416/SPS;
 for(cnt;cnt<SPS*2+chan;cnt+=2)
 {
  buf[cnt]=(unsigned char)(cos(phase+cnt*x)*amp+127);
 }
}
//---------------------------------------------------------------------------

FGErrMsg GenFreq(void)
{
 waveOutReset(ghwo);
 if(mmres != MMSYSERR_NOERROR)
  return "Cant reset device.";
 mmres=waveOutWrite(ghwo,&pwh,sizeof(WAVEHDR));
 if(mmres != MMSYSERR_NOERROR)
  return "Cant write  data to device.";
 return NULL;
}
//---------------------------------------------------------------------------

FGErrMsg StopGen(void)
{
 mmres=waveOutReset(ghwo);
 if(mmres != MMSYSERR_NOERROR)
  return "Cant stop device.";
 return NULL; 
}

