//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "Main.h"
#include "Generator.cpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#define _2DP 0.006283185          // Delta Phase*2 == 2*Pi/(PhaseTrackBar->Max == 1000)
#define DP 0.003141593            // Delta Phase
#define Left 1
#define Right 0

int width;
TMForm *MForm;
FGErrMsg ErrTxt;
//---------------------------------------------------------------------------

__fastcall TMForm::TMForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TMForm::FormCreate(TObject *Sender)
{
 ErrTxt=PrepareDevice();
  if(ErrTxt!=NULL)
  {
   ShowMessage(ErrTxt);
   Close();
  }
 char temp[1];
 if((int)FindExecutable("sndvol32.exe",NULL,temp)>32) // If SoundVolumeControl installed
 {
  HICON SmIcon;
  TIcon *Icon;
  Icon=new TIcon();
  Graphics::TBitmap *Bitmap;
  Bitmap=new Graphics::TBitmap();
  Bitmap->TransparentColor=clBtnFace;
  Bitmap->Canvas->Brush->Color=clBtnFace;
  Bitmap->Height=16;
  Bitmap->Width=16;
  ExtractIconEx("sndvol32.exe",0,NULL,&SmIcon,1); // Get the small icon from exe
  Icon->Handle=SmIcon;
  Bitmap->Canvas->Draw(0,0,Icon);
  SndVolButton->Glyph=Bitmap;
  delete Icon;
  delete Bitmap;
  SndVolButton->Visible=true;
 }
 width=FImage->Canvas->ClipRect.right+1;
 LFreqTrackBarChange(this);
 RFreqTrackBarChange(this);
 LPhaseTrackBarChange(this);
 RPhaseTrackBarChange(this);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::FormClose(TObject *Sender, TCloseAction &Action)
{
 ErrTxt=CloseDevice();
 if(ErrTxt!=NULL)
   ShowMessage(ErrTxt);
}
//---------------------------------------------------------------------------

void __fastcall TMForm::StartButtonClick(TObject *Sender)
{
 if(StartButton->Caption=="Start")
 {
  ErrTxt=GenFreq();
  if(ErrTxt!=NULL)
   ShowMessage(ErrTxt);
  else
   StartButton->Caption="Stop";
 }
 else
 {
  ErrTxt=StopGen();
  if(ErrTxt!=NULL)
   ShowMessage(ErrTxt);
  else
   StartButton->Caption="Start";
 }
}
//---------------------------------------------------------------------------

void __fastcall TMForm::LFreqTrackBarChange(TObject *Sender)
{
 LFEUpDown->Position=LFreqTrackBar->Position;
 LFreqEdit->Text=FloatToStr(LFreqTrackBar->Position);
 FillBuf(LFreqTrackBar->Position,127-LAmplitudeTrackBar->Position,_2DP*LPhaseTrackBar->Position,Left);
 MRepaint();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::RFreqTrackBarChange(TObject *Sender)
{
 RFEUpDown->Position=RFreqTrackBar->Position;
 RFreqEdit->Text=FloatToStr(RFreqTrackBar->Position);
 FillBuf(RFreqTrackBar->Position,127-RAmplitudeTrackBar->Position,_2DP*RPhaseTrackBar->Position,Right);
 MRepaint();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::LPhaseTrackBarChange(TObject *Sender)
{
 LPhaseEdit->Text=DP*LPhaseTrackBar->Position;
 FillBuf(LFreqTrackBar->Position,127-LAmplitudeTrackBar->Position,_2DP*LPhaseTrackBar->Position,Left);
 MRepaint();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::RPhaseTrackBarChange(TObject *Sender)
{
 RPhaseEdit->Text=DP*RPhaseTrackBar->Position;
 FillBuf(RFreqTrackBar->Position,127-RAmplitudeTrackBar->Position,_2DP*RPhaseTrackBar->Position,Right);
 MRepaint();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::LFEUpDownClick(TObject *Sender, TUDBtnType Button)
{
 LFreqTrackBar->Position=LFEUpDown->Position;
}
//---------------------------------------------------------------------------

void __fastcall TMForm::RFEUpDownClick(TObject *Sender, TUDBtnType Button)
{
 RFreqTrackBar->Position=RFEUpDown->Position;
}
//---------------------------------------------------------------------------

void __fastcall TMForm::LFreqEditKeyPress(TObject *Sender, char &Key)
{
 if(Key==13)
 {
  int val;
  try
  {
   val=StrToFloat(LFreqEdit->Text);
  }
  catch (...)
  {
   LFreqEdit->Text=LFreqTrackBar->Position;
   return;
  }
  LFreqTrackBar->Position=val;
 }
}
//---------------------------------------------------------------------------

void __fastcall TMForm::RFreqEditKeyPress(TObject *Sender, char &Key)
{
 if(Key==13)
 {
  int val;
  try
  {
   val=StrToFloat(RFreqEdit->Text);
  }
  catch (...)
  {
   RFreqEdit->Text=RFreqTrackBar->Position;
   return;
  }
  RFreqTrackBar->Position=val;
 }
}
//---------------------------------------------------------------------------

void __fastcall TMForm::LAmplitudeTrackBarChange(TObject *Sender)
{
 FillBuf(LFreqTrackBar->Position,127-LAmplitudeTrackBar->Position,_2DP*LPhaseTrackBar->Position,Left);
 MRepaint();
}
//---------------------------------------------------------------------------

void __fastcall TMForm::RAmplitudeTrackBarChange(TObject *Sender)
{
 FillBuf(RFreqTrackBar->Position,127-RAmplitudeTrackBar->Position,_2DP*RPhaseTrackBar->Position,Right);
 MRepaint();
}
//---------------------------------------------------------------------------

void TMForm::MRepaint()
{
 FImage->Canvas->FillRect(FImage->Canvas->ClipRect); // Clear the canvas
 FImage->Canvas->MoveTo(0,buf[0]/2);
 FImage->Canvas->Pen->Color=clBlue;
 for(int cnt=0;cnt<width;cnt++)
  FImage->Canvas->LineTo(cnt,buf[cnt*2]/2);
 FImage->Canvas->MoveTo(0,buf[1]/2);
 FImage->Canvas->Pen->Color=clRed;
 for(int cnt=0;cnt<width;cnt++)
  FImage->Canvas->LineTo(cnt,buf[cnt*2+1]/2); 
}
//---------------------------------------------------------------------------

void __fastcall TMForm::SndVolButtonClick(TObject *Sender)
{
 WinExec("sndvol32.exe",SW_RESTORE);
}
//---------------------------------------------------------------------------

